\begin{usage}
Assignment 2, Year 2002, Winter Term, School of Computer Science at the University of Waterloo.
\end{usage}
\begin{authorship}
  (Lewis \& Denenberg, pg 126)
\end{authorship}

\begin{enumerate}
\item  Let $B(n)$ denote the number of different binary trees 
with $n$ nodes.  Note that $B(1)=1, B(2)=2$.  Determine
$B(3), B(4)$ and $B(5)$ and use these to write a recurrence
relation for $B(n)$.


\begin{solution}
  If a tree has $n$ nodes, then there is one for the root, and $n-1$
  split between the two children. So the formula for $B(n)$ is the sum
  of all the possibilities, where each posibility is the
  multiplication of the possibilites for each child. For example, a
  tree with $k$ nodes on the left, and $l$ nodes on the right, will
  have $B(k)B(l)$ possibilities.

Therefore,
\begin{displaymath}
B(n) = \left\{ 
\begin{array}{ll}
1 & \textrm{for $n=0,1$} \\ 
\sum_{i=0}^{n-1} B(i)B(n-1-i) & \textrm{for $n \geq 2$} 
\end{array} 
\right.
\end{displaymath}
Applying this recurrence relation give us that $B(3)=5, B(4)=14, B(5)=42.$

\end{solution}

\item Let $H(h)$ denote the number of different binary trees 
with height $h$.  Note that $H(0)=1, H(1)=3$.  Determine
$H(2), H(3)$ and $H(4)$ and use these to write a recurrence
relation for $H(h)$. 

\begin{solution}
  If a tree has height $h$, then one of the children has height $h-1$,
  and the other child can be an empty tree, or a tree of height $0$ to
  $h-1$. So the possibilities are $h-1$ on the right and empty or
  $0..h-2$ on the left, $h-1$ for both, or $h-1$ on the left and empty
  or $0..h-2$ on the right. So,

\begin{displaymath}
H(n) = \left\{
\begin{array}{ll}
1 & \textrm{for $n=0$} \\
3 & \textrm{for $n=1$} \\ 
H(h-1)^2 + 2*H(h-1) \Big( 1 + \sum_{i=0}^{h-2} H(i) \Big) & \textrm{for $n \geq 2$}
\end{array} \right.
\end{displaymath}
Applying this recurrence relation gives us that $H(2)=21, H(3)=651, H(4)=457653.$

\end{solution}
\end{enumerate}

\begin{INUTILE}
\begin{markingScheme}{	\vspace{15pt}
	( 5 marks )

	\vspace{10pt}
	\begin{itemize}
	\item 4 marks for algorithm
	\item 1 mark for O(n) reasoning
	\end{itemize}
}
\end{markingScheme}
  
\end{INUTILE}
